Bug 175997 - Should not acquire Children.MUTEX in PackageViewChildren
Should not acquire Children.MUTEX in PackageViewChildren
Status: REOPENED
Product: java
Classification: Unclassified
Component: Project
6.x
All All
: P3 (vote)
: 6.x
Assigned To: Tomas Zezula
issues@java
73-reviewed
: THREAD
Depends on: 177110
Blocks:
  Show dependency treegraph
 
Reported: 2009-11-04 10:16 UTC by Milan Kubec
Modified: 2012-10-26 12:03 UTC (History)
1 user (show)

See Also:
Issue Type: DEFECT
:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Milan Kubec 2009-11-04 10:16:47 UTC
For details about this issue see issue #151498.

java.lang.IllegalStateException: Should not acquire Children.MUTEX while holding ProjectManager.mutex()
        at org.openide.nodes.Children$ProjectManagerDeadlockDetector.execute(Children.java:1808)
        at org.openide.util.Mutex.postRequest(Mutex.java:1245)
        at org.openide.util.Mutex.postRequest(Mutex.java:1209)
        at org.openide.util.Mutex.postWriteRequest(Mutex.java:582)
        at org.openide.nodes.Children$Keys.applyKeys(Children.java:1513)
        at org.openide.nodes.Children$Keys.setKeys(Children.java:1457)
        at org.netbeans.spi.java.project.support.ui.PackageViewChildren.refreshKeys(PackageViewChildren.java:244)
        at org.netbeans.spi.java.project.support.ui.PackageViewChildren.fileFolderCreated(PackageViewChildren.java:396)
Caused: java.lang.reflect.InvocationTargetException
        at sun.reflect.GeneratedMethodAccessor60.invoke(GeneratedMethodAccessor60.java:0)
        at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:25)
        at java.lang.reflect.Method.invoke(Method.java:597)
        at org.openide.util.WeakListenerImpl$ProxyListener.invoke(WeakListenerImpl.java:451)
Caused: java.lang.reflect.UndeclaredThrowableException
        at $Proxy1.fileFolderCreated(.java:0)
        at org.openide.filesystems.FCLSupport$DispatchEventWrapper.dispatchEventImpl(FCLSupport.java:133)
        at org.openide.filesystems.FCLSupport$DispatchEventWrapper.dispatchEvent(FCLSupport.java:122)
        at org.openide.filesystems.FCLSupport.dispatchEvent(FCLSupport.java:99)
        at org.openide.filesystems.FileObject$ED.dispatch(FileObject.java:1052)
        at org.openide.filesystems.EventControl.invokeDispatchers(EventControl.java:203)
        at org.openide.filesystems.EventControl.exitAtomicAction(EventControl.java:177)
        at org.openide.filesystems.EventControl.runAtomicAction(EventControl.java:122)
        at org.openide.filesystems.FileSystem.runAtomicAction(FileSystem.java:509)
        at org.netbeans.spi.project.support.ant.AntProjectHelper.runSaveAA(AntProjectHelper.java:318)
        at org.netbeans.spi.project.support.ant.AntProjectHelper.saveXml(AntProjectHelper.java:334)
        at org.netbeans.spi.project.support.ant.AntProjectHelper.save(AntProjectHelper.java:606)
        at org.netbeans.spi.project.support.ant.AntProjectHelper.access$100(AntProjectHelper.java:103)
        at org.netbeans.spi.project.support.ant.AntProjectHelper$1.save(AntProjectHelper.java:141)
        at
org.netbeans.modules.project.ant.AntBasedProjectFactorySingleton.saveProject(AntBasedProjectFactorySingleton.java:360)
        at org.netbeans.api.project.ProjectManager$6.run(ProjectManager.java:643)
        at org.netbeans.api.project.ProjectManager$6.run(ProjectManager.java:632)
        at org.openide.util.Mutex.writeAccess(Mutex.java:433)
        at org.netbeans.api.project.ProjectManager.saveProject(ProjectManager.java:632)
        at org.netbeans.modules.project.ui.OpenProjectList.close(OpenProjectList.java:793)
        at org.netbeans.modules.project.ui.actions.CloseProject.actionPerformed(CloseProject.java:73)
        at org.netbeans.modules.project.ui.actions.LookupSensitiveAction.actionPerformed(LookupSensitiveAction.java:166)
        at javax.swing.AbstractButton.fireActionPerformed(AbstractButton.java:1995)
        at javax.swing.AbstractButton$Handler.actionPerformed(AbstractButton.java:2318)
        at javax.swing.DefaultButtonModel.fireActionPerformed(DefaultButtonModel.java:387)
...
Comment 1 Milan Kubec 2009-11-05 14:16:36 UTC
Fixed.

http://hg.netbeans.org/core-main/rev/03e06da26d49
Comment 2 Quality Engineering 2009-11-06 09:59:14 UTC
Integrated into 'main-golden', will be available in build *200911060201* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/03e06da26d49
User: Milan Kubec <mkubec@netbeans.org>
Log: #175997: refreshKeys should be async to avoid possible deadlock
Comment 3 Milan Kubec 2009-11-19 02:59:29 UTC
Had to be rollbacked, for details see issue #177110.
Comment 4 Quality Engineering 2009-11-19 15:03:58 UTC
Integrated into 'main-golden', will be available in build *200911191401* on http://bits.netbeans.org/dev/nightly/ (upload may still be in progress)
Changeset: http://hg.netbeans.org/main/rev/8497a06e01fd
User: Milan Kubec <mkubec@netbeans.org>
Log: #177110: empty packages visible in Projects view; rollback of #175997 fix
Comment 5 David Strupl 2012-10-25 13:41:46 UTC
Bug prior to 7.0, not touched for the last 2 years --> P4.


By use of this website, you agree to the NetBeans Policies and Terms of Use. © 2012, Oracle Corporation and/or its affiliates. Sponsored by Oracle logo